import { Scope } from './scope';
import { BaseSchemes } from './types';
export declare type Root<Scheme extends BaseSchemes> = {
    type: 'nodecreate';
    data: Scheme['Node'];
} | {
    type: 'nodecreated';
    data: Scheme['Node'];
} | {
    type: 'noderemove';
    data: Scheme['Node'];
} | {
    type: 'noderemoved';
    data: Scheme['Node'];
} | {
    type: 'connectioncreate';
    data: Scheme['Connection'];
} | {
    type: 'connectioncreated';
    data: Scheme['Connection'];
} | {
    type: 'connectionremove';
    data: Scheme['Connection'];
} | {
    type: 'connectionremoved';
    data: Scheme['Connection'];
} | {
    type: 'clear';
} | {
    type: 'clearcancelled';
} | {
    type: 'cleared';
};
export declare class NodeEditor<Scheme extends BaseSchemes> extends Scope<Root<Scheme>> {
    private nodes;
    private connections;
    constructor();
    getNode(id: Scheme['Node']['id']): Scheme["Node"];
    getNodes(): Scheme["Node"][];
    getConnections(): Scheme["Connection"][];
    getConnection(id: Scheme['Connection']['id']): Scheme["Connection"];
    addNode(data: Scheme['Node']): Promise<boolean>;
    addConnection(data: Scheme['Connection']): Promise<boolean>;
    removeNode(id: Scheme['Node']['id']): Promise<boolean>;
    removeConnection(id: Scheme['Connection']['id']): Promise<boolean>;
    clear(): Promise<boolean>;
}
//# sourceMappingURL=editor.d.ts.map