import { Tail } from './utility-types';
export declare type Pipe<T> = (data: T) => Promise<undefined | T> | undefined | T;
export declare class Signal<T> {
    pipes: Pipe<T>[];
    addPipe(pipe: Pipe<T>): void;
    emit<Context extends T>(context: Context): Promise<Context | undefined>;
}
export declare class Scope<Produces, Parents extends unknown[] = []> {
    name: string;
    signal: Signal<any>;
    parent?: any;
    constructor(name: string);
    addPipe(middleware: Pipe<Produces | Parents[number]>): void;
    use<T>(scope: Scope<T, [Produces, ...Parents]>): void;
    setParent(scope: Scope<Parents[0], Tail<Parents>>): void;
    emit(context: Produces): Promise<Produces>;
    hasParent(): boolean;
    parentScope<T extends Parents[0], P extends Tail<Parents>>(): Scope<T, P>;
    parentScope<T>(type: {
        new (...args: any[]): T;
    }): T;
}
//# sourceMappingURL=scope.d.ts.map